2024-07-25 - Version 4.0.0
- New: Configurable 3 band biquad EQ added to main mix, global effects, and instruments
- New: Launchpad Pro MK3 MIDI Control Surface support added in MIDI Settings view
- New: Instrument Pool view for managing instruments as a list
- New: Post-filter LIMIT/CLIP distortion modes added: POST:W1 and POST:W2 (Waveshaper 1 and 2)
- New: Wavsynth "OVERFLOW" shapes (literal data overflow) replaced with 60+ wavetables
- New: Wavsynth MIRROR parameter renamed SCAN due to being able to scan the new wavetables
- New: ZDF (zero delay feedback) lowpass and highpass filter added to filter type
- New: Scales now have a global tuning parameter to diverge from A440
- New: Table TIC FE mode - The first 12 rows of the table are mapped to note
- New: FX commands: DJC,DJR,DJT (renamed DJF to DJC) for sequencing the DJ filter
- New: FX command: RTO (Repeat To) - Holds the repeat command (REP) at a specific value
- New: FX command: ARC (Arp config) - Set the tic rate, arp direction, and number of octaves for the ARP command
- New: FX command: EQM and EQI FX commands for setting the EQ bank for song mix or the current instrument
- New: FX command: GGR (Global groove) - Set the groove for all tracks
- New: FX command: INS (Instrument) - Set the current instrument
- Improved: No longer exit from Live-mode after loading a song 
- Improved: "DRUNK" LFO shape no longer retriggers from zero
- Improved: ADSR now has better scaling on the low range (more small values)
- Improved: PITCH mod destination amount now has better scaling on the low range
- Improved: Play button always stops if sequence is running (regardless of phrase / chain / song playback)
- Improved: FX list view has a new category for instrument envelopes
- Improved: Trig envelope now triggers correctly if the trigger event happened before the instrument started
- Improved: Delay send FX now has a mono/summed input (was left channel only before)
- Improved: Pre-load samples on song queued load for better initial triggering of samples 
- Fix: When out of phrases, cloning did not display an error
- Fix: Disable remote display for boot options view
- Fix: Instrument - Delete shortcut ([OPT]+[EDIT]) on LOAD or SAVE instrument deleted characters from instrument name
- Fix: Tearing artifact on value sliders (more prevalent on Model:02)
- Fix: Instrument Mod - Trig envelope did not work correctly when using multiple instruments (some without a trig mod) in the same track
- Fix: Big-font mode song navigation issue on track 8 if the info area appeared
- Fix: Info area mini-map displayed the wrong [P] position when navigating up from Chain view
- Fix: Phrase - When using scales it was possible to edit notes past note number 127 
- Fix: Cursor clearing issues on big font mode when toggling right side info area
- Fix: When editing down a note using scale on the lowest octave, it could toggle between C-1 and the lowest scale note
- Fix: Sample Editor - Xfade loop could cause distortion with 24 bit wav files 
- Fix: DEL (Delay FX command) with a HOPFF in the same row caused a crash

2024-06-23 - Version 3.3.3A
- Fix: Bigfont mode easteregg-mode issue with mixer screen

2024-06-22 - Version 3.3.3
- Improved: Drawing waveform oscilloscope optimizations (including easter-egg on Model:02)
- Improved: When in MIDI sync receive mode, display a "WAITING FOR SYNC" message when there is no incoming sync
- Fix: Fixed rare hard-crash using sampler instruments
- Fix: Sampler - Disable file based loop markers when using slice
- Fix: Sampler - PIT FX command range was limited when using slices
- Fix: Sampler - Degrade automation never reset fully to zero (re-enable interpolation) until sampler retriggered
- Fix: Phrase OPT+LEFT/RIGHT navigation could crash if adjacent track has a chain with no phrases (again)

2024-06-11 - Version 3.3.2A
- Fix: Disabled a battery saving method on Model:02 that caused hard-crashes on some units

2024-06-03 - Version 3.3.2
- Fix: Phrase OPT+LEFT/RIGHT navigation could crash if adjacent track has a chain with no phrases 
- Fix: Drum Envelope - Note off messages were not always ignored
- Fix: Sample editor - Track number help text for Ext. instrument track sampling was incorrect
- Fix: Sample editor - Exit editor when microSD Card is removed to prevent attempting to record without a card present
- Fix: LFO "Drunk" shape misbehaving on reboot if Freq is set to zero

2024-05-25 - Version 3.3.1A
- Fix: Rendering - Repeat did not work correctly 

2024-05-24 - Version 3.3.1
- Fix: Dual mono input mode FX sends were broken / routed incorrectly
- Fix: Rendering - Repeat did not work correctly 
- Fix: Sample Editor - Using OPT+DIRECTION to selection snap to tempo could have a rounding error
- Fix: Sample Editor - If track was muted preview was not possible
- Fix: Instrument - Copy/paste help text was not present when pasting
- Fix: Instrument - Clear copy/paste buffer when starting a new song
- Fix: Song - Empty phrase with a Instrument column value present colored the chain as empty

2024-05-01 - Version 3.3.0A
- Fix: Stats view - Battery charge timer was not resetting
- Fix: Song view - Selection mode playback bug with looping selection 

2024-04-29 - Version 3.3.0
- New: M8 Model:02 Support
- New: Time Stats view (playing time, song work time, system/battery and set file date) accessible from project view
- New: Cursor style changed
- New: Instrument modulation new destination - "MOD BINV" (Mod Both - Inverse) Like "MOD BOTH" but with an inverted rate
- Improved: CPU Optimizations
- Improved: Stuck-key reliability  
- Improved: SD card sample streaming performance improvements
- Improved: Theme view - Changing theme colors only refreshes screen when needed
- Fix: DEL FX command was not working in tables
- Fix: XRZ Reverb Freeze FX command had audible artifacts
- Fix: PSL FX command (pitch slide) was not working in tables running at TICFF
- Fix: RET FX command (retrig) in a aux table could affect TBX command (aux table)
- Fix: NTH FX command help text was cut off on big font mode
- Fix: VMV FX command (main volume) had incorrect help text for tables
- Fix: Selection playback looping in phrase and chain did not work correctly with HOP and grooves
- Fix: Hypersynth - Chord changing no longer affects playback when CHD Fx command is active
- Fix: Sampler - SLI FX command (slice) used with STA (start offset) was working incorrectly
- Fix: Sampler - Playing invalid sample markers are now ignored
- Fix: MIDIOUT - Pitch/Velocity Tracking Modulator was reset on note offs 
- Fix: Song view - Switching to live mode after playing a selected region could make live mode not process cues
- Fix: file Browser - Previewing or selecting after sorting directory could select the wrong sample
- Fix: Instrument modulation view - [OPT]+[LEFT or RIGHT] navigation could move cursor into an empty region
- Fix: Phrase view - [OPT]+[LEFT or RIGHT] navigation into a track chain with no phrases was not skipped
- Fix: Instrument Panning - hard left pan could bleed into the right channel
- Fix: File Browser / Song - Deleting a wav file in browser should be removed from active song
- Fix: Song Bundling - Overwriting now checks wav file sizes when determining changes made for copying
- Fix: Sample Editor - Crop / Delete to remove slice markers that are out of range
- Fix: Sample Editor "Overwrite" now respects changing the sample name field
- Fix: ADSR Envelope assigned to panning did not work with a negative amount
- Fix: ADSR Envelope release was not affected by decay/release FX command
- Fix: MIDI input to an external MIDIOUT instrument caused hanging notes when in poly mode
- Fix: Switching to headphones on some M8 models may have speaker related optimizations enabled
- Fix: Render - Repeat Song option could not be respected
- Fix: Song View - Exiting selection mode could cause cursor to jump to an unexpected row
- Fix: Naming a song while song load queue is trigger would result in not being able to exit the on-screen keyboard
- Fix: Theme color changes to only refresh entire display when necessary

2023-11-15 - Version 3.2.7
- Fix: MIDI Clock was not being sent if playback was stopped (3.2.6 issue)
- Fix: Render - Render option "Repeat song XX" would cause artifacts on repeats 

2023-11-10 - Version 3.2.6
- Improved: MIDI sync and transport improved when switching songs in song load queue mode
- Improved: MIDI send sync and/or send transport will transmit while receive sync and/or transport is enabled
- Improved: Project - Tempo nudge now works with receive MIDI sync mode
- Fix: MIDI sync latency issue when receive transport is in song mode
- Fix: Stereo Delay could have audible artifacts when in receive MIDI sync mode or changing feedback parameter
- Fix: Rendering song with External instrument type active could have audible artifacts in render
- Fix: Sampler - Rendering issue with sampler and preserving transients
- Fix: Sampler - OSC mode was not working correctly
- Fix: Sampler - Quick sample browse (EDIT+LEFT/RIGHT on sample name) did not work with uppercase "WAV" file selection
- Fix: Sample Editor - Normalization did not work after performing a cross fade loop
- Fix: Sample Editor - Deleting a selection would not update loop points correctly
- Fix: Note KIL FX command would not allow new instrument triggers if note value was not set
- Fix: Tables with TIC00 would not work with HOP FX command when HOP value is the same as the current row
- Fix: Bigfont mode mini-map could show the wrong location when navigating
- Fix: Song - Vertical scroll position could jump when exiting selection

2023-10-12 - Version 3.2.5
- Fix: Rendering could cause file corruption when samples have not been initialized/played before rendering began
- Fix: Rendering could have wrong length
- Fix: Rendering could have an initial fade-in at beginning
- Fix: Sample editor loop point playback could sound incorrectly when the loop end point was at end of file
- Fix: Midiout Instrument: Help text for MPB and MPG was wrong
- Fix: Big font mode could display the wrong mini map when quickly navigating screens

2023-09-14 - Version 3.2.4
- Fix: Instrument Modulation to Modulation could not work correctly on power-up
- Fix: MIDIOUT Instrument ADD FX command would not do negative relative FX values
- Fix: MIDIOUT Internal MIDI mode did not work with note-off events for control map mode (Mute/Solo)
- Fix: Some wav samples with loop markers would not load the marker information
- Fix: Instrument "Failed to save" erroneous message when switching instruments (not saving)
- Fix: Sample Editor Automatic-slicing could have a tiny first slice
- Fix: Sample Editor "ARM" marker was missing from the VU meter for sampling input
- Fix: Phrase Random-Fill notes down could end up removing notes from sequence
- Fix: Table - Editing FX command via EDIT+LEFT/RIGHT would stop before end of list
- Fix: OFF (Note-off) FX command on the same line as a KIL would overwrite the KIL event
- Fix: DEL (Delay row) with HOP fx commands would not play note once HOP occurred
- Fix: Reporting the current song time (hold OPT when playback is stopped) would freeze M8 if all song rows (00-FF) were consumed

2023-08-13 - Version 3.2.3
- Improved: Aux table FX command TBX can now use THO on the same row to HOP to a table position
- Fix: Battery charge status (charging animation) issue on some hardware M8 units
- Fix: Stereo Delay interpolation issue (clicks) when changing delay time or BPM
- Fix: Randomize left FX command (RNL) could randomize outside the desired random range
- Fix: Aux Table random table hop did not work correctly with tic00

2023-07-12 - Version 3.2.2
- Improved: Touchscreen MIDI mapping performance improvements on busy projects
- Fix: Charge status issue on some M8 production units
- Fix: Audible artifacts when viewing Inst. Mod view using mod modulation from MOD4 to MOD1

2023-07-10 - Version 3.2.1
- New: Project tempo and transpose can now be MIDI & touchscreen mapped
- New: Project view now has nudge option "<>" for tempo
- Fix: Sample editor undo could cause crash when undoing a recording
- Fix: Sample editor processes could result in pops/clicks on certain microSD cards
- Fix: Sample editor slice markers could get lost/scrambled when deleting a selected area
- Fix: MIDIOUT CHD 3rd interval could be played at wrong octave when transpose was disabled
- Fix: Big font mode on phrase: info area could have drawing issues when selection was active
- Fix: Theme view could have display issue when first viewing theme

2023-06-30 - Version 3.2.0
- New: Instrument Modulation can now modulate modulators
- Improved: Sampler supports up to 128 slice markers (from 32)
- Improved: Mute/Solo display in Song view next to track numbers
- Improved: Tracking modulation can now disable velocity to volume using "Velocity (Takeover)" as source.
- Improved: MIDI Input record channel now works with the "NOTE PREVIEW" setting in project view when auditioning notes
- Fix: Sample playback with LFO to loop start could have dropouts
- Fix: Wavsynth - Possible CPU too busy messages when playing back multiple tracks
- Fix: Possible crash with RMX FX command on retrieving song length (Hold OPT on song position with playback stopped)
- Fix: Hypersynth chord editing values could jump from previous chord edited value

2023-06-16 - Version 3.1.4
- Fix: Sampler LFO on Loop Start issues/artifacts from version 3.1
- Fix: Big font effects list screen could have empty instrument section (still)
- Fix: Sample editor - Editing selection end with tempo snapping (OPT+Up/Down) may offset a step

2023-06-14 - Version 3.1.3
- Fix: Big font effects list screen could have empty instrument section
- Fix: Sample editor issues from previous version (process:slice issues)
- Fix: Save changes dialog being stuck when exiting sample editor
- Fix: Midiout instrument - Note values now rounded when selected scale has cent offsets

2023-06-13 - Version 3.1.2
- New: Added sample editor processes: delete, duplicate, silence, fade in, fade out, crossfade loop
- Improved: Sample loop playback with loop markers now has seamless looping
- Improved: Sample editor displaying waveform selection and markers accuracy 
- Improved: SD card sample streaming improvements for specific microSD cards 
- Fix: Stem rendering failing when samples have not been initialized
- Fix: Rendering could include audio input / USB audio input interference
- Fix: Sample editor playback quickly faded volume up from zero, undesired for checking for clicks at beginning of sample
- Fix: Song view with big font - Show right side info when using [Opt+Left/Right] quick-mute shortcuts

2023-06-04 - Version 3.1.1
- Fix: Midiout program change sent erroneous or frequent messages
- Fix: Big font note insert issue while holding and releasing shift

2023-06-01 - Version 3.1.0
- New: Big font option for M8 hardware accessible in Theme view under font options
- New: MIDIOUT Instrument - PIT and VOL FX commands added (VOL is sent as CC7)
- Improved: Hypersynth - Editing chord values can now jump an octave relative to scale setting ([Edit]+[Up or Down])
- Fix: Midi send transport stop when all tracks stopped playing
- Fix: MIDI MAPPING view potential crash after instrument change/deletion
- Fix: Live quantize setting in project could result in misaligned chains when cuing
- Fix: Instrument - Changing TIC rate away from 00 needed the track to restart to take effect
- Fix: Sampler - Clearing/removing sample name (EDIT+OPT) in sampler allowed sample to continue playing
- Fix: Groove - Interpolate shortcut did not work 

2023-04-28 - Version 3.0.4
- Fix: Critical issue with sampler when saving files sometimes failed to save
- New: Phrase note fill shortcuts - While in selection mode highlight note column and rows and use:
-   [Opt]+[Left] to cycle between fill spacings
-   [Opt]+[Right] to randomly generate a note sequence. Select both note and velocity to random velocity
-   [Opt]+[Up] to randomize the notes up
-   [Opt]+[Down] to randomize notes down
-   Undo is possible by using the paste shortcut after exiting selection mode [Shift]+[Edit] 
- Improved: External instrument no longer stops audio on OFF commands
- Improved: Phrase editing note preview now works with ARP and vibrato FX commands
- Improved: Sampler Slice FX command now works in conjunction with Start offset command
- Fix: Sampler had slight volume issue on new notes when using sample loop mode 
- Fix: MIDIOUT program change bank would fail to send on occasion
- Fix: MIDI input could hang notes if table has a note transpose
- Fix: Theme view clearing background color would not reset the background

2023-04-08 - Version 3.0.3
- Improved: Hypersynth chords can now be copied/pasted via copy paste shortcut ([Shift]+[Opt], [Shift]+[Edit]) when cursor is on the chord row
- Improved: Help text is now displayed when editing Midiout and External instrument CC values
- Improved: Stem rendering is now possible with Midiout instruments using "Internal" mode
- Fix: Listening to USB audio input while rendering would create bad rendered files
- Fix: M8 could crash on Instrument Mod view if there is no instrument under certain conditions
- Fix: Stem rendering did not apply global FX commands from a instrument table not actively playing in the current stemmed track
- Fix: Headless: Settings / themes was not recalled on power-up
- Fix: Inst/Table "clear unused" would clear aux tables and RNL triggered instruments

2023-03-31 - Version 3.0.2
- New: Sample editor now displays help text for selection length
- Improved: External Synth - better envelope handling to prevent pops/clicks
- Fix: External Synth - CC FX commands could cause "green dot" position indicator to be drawn wrong
- Fix: Trig envelope could be set to the wrong position when switching between instruments on the same track

2023-03-27 - Version 3.0.1
- Fix: External Synth default volume was a bit quiet due to VOL FX command
- Fix: External Instrument Program change message did not properly send bank
- Fix: Sample Editor could save corrupt file if waveform was still being drawn while saving
- Fix: Typo in FX command name for Trig env decay (Now: "DE[1-4]" ... was "SU[1-4]")
- Fix: Interpolation issue / hard volume cut when not using an envelope for volume with the KIL command
- Fix: Trig envelope could get "stuck" until power reset

2023-03-22 - Version 3.0.0
- Note!!!!: Output/Speaker volume has moved to the top of the mixer view (previously in project view)
- Note!!!!: Songs that have previously had Volume assigned to an LFO will need to be adjusted manually due to a bug in volume calculation
- New: Hypersynth instrument (stereo chord synth)
- New: External instrument (send MIDI and receive audio for processing)
- New: Envelopes and LFOs have been replaced with 4 configurable modulation slots
-   New: Bipolar ADSR envelope - The release stage can be triggered via new note-off note/command, or external MIDI input
-   New: Drum Envelope - High initial peak value for transient shaping with a hold/body stage that slowly swells
-   New: Follow envelope - Simple ADH (Attack, hold, decay) envelope that can be trigger by another instrument or track in the song
-   New: Key or velocity modulation source for mapping note/velocity
- New: Note Offs can be entered in the note column by deleting/clearing a empty note "---" via OPT+EDIT 
- New: DJF Now has modes (LP:HP, LP:BP, or BP:HP)
- New: Default groove (was groove 0) can be defined in the project view
- New: Default scale and Key signature (was scale 0) can be set on the project view
- New: Song preview has been added to the file browser when loading a song via [PLAY] (if the song is not currently playing)
- New: Random name generator in the text entry "keyboard" view
- New: Note Trigger indication for playing tracks located next to notes in info area
- New: OFF Fx Command - Like KIL to stop sound but for use with ADSR to trigger key-release stage.
- New: RMX FX Command - (Remix) Set the playhead to a specified position on all tracks to the left of command's track
- New: RNL FX Command - (Random left) Randomize the command to the left of RNL a specified amount
- New: TBX FX Command - (Aux table) Plays a second table in the given phrase that is played in conjunction (but not in sync) with the instrument's table
- New: DEL FX Command implemented in table
- Improved: REP FX Command (Repeat last effect) now has wider range for slower control
- Improved: Midiout Instrument now has envelope nad LFO modulation for CCs
- Improved: Delay send effect now has smoother transitions when changing delay time or tempo
- Improved: Phrase and table share last edited value for command fx
- Improved: To automatically select a command fx, press edit on a parameter in the Instrument and mod views to copy it's fx command
- Improved: Phrase/Table: When pasting 16 rows starting on the top row, the cursor will stay on the top row instead of scrolling to the bottom
- Improved: Added colors to the mute/solo "M" and "S" text in the right-side info area for visibility
- Improved: REP commands not stopped in previous phrases now have a visual indication in current phrase screen as "^^" next to FX command label 
- Improved: Scope has been improved when high pitch notes occur
- Improved: Mixer has better metering. General UI improvements across all views
- Improved: Sample editor - Slices now appear as markers and values can be copy/pasted (SHIFT+OPT, SHIFT+EDIT)
- Improved: Sample editor - Ranges / Slices can be adjusted / set via Touchscreen+[EDIT]
- Improved: Scales and Themes now support custom save folders
- Fix: Midimap view visual scrolling issue on destinations
- Fix: Midiout Program change and bank not sending on occasion
- Fix: Sample OSC loop mode on tiny region could result in wrong waveform offset and pitch changes

2022-09-04 - Version 2.7.8
- Fix: Speaker related crashes on some M8 hardware units
- Fix: 24bit wav file could fail to open
- Fix: File browser - Refresh current directory on saving files
- Fix: File browser - Song playback preview consistency issue and added messages
- Fix: File browser - Instrument preview issue with some tables (TIC00 being held)
- Fix: FMSynth - OP Feedback for resonance control of noise shapes resulted in wrong behavior for NHP and NBP
- Fix: FMSynth - OP Feedback for phase control of CLK shape did not work correctly

2022-08-09 - Version 2.7.7
- Improved: More better handling of instrument switching in the same track during playback, cleaner switch/mixing.
- Fix: MIDI control of mixer volume could result in audible clicks in 2.7.6
- Fix: 2.7.6 issue with sample playback occasional slow volume attack
- Fix: MIDI input poly mode may not have used all tracks during playback if song transpose was enabled
- Fix: When using phrase playback loading a song, song would play random phrase

2022-07-30 - Version 2.7.6
- Improved: Better handling / less artifacts of instrument switching in the same track during playback.
- Fix: Loading a wav file in instrument load did not work in version 2.7.5
- Fix: Sorting a directory in browser view listed numbered files before directories
- Fix: Small graphical issue with creating directory when in a long file path

2022-07-28 - Version 2.7.5
- Fix: Bundling a song with samples could lead to a crash or incomplete bundling.
- Fix: Saving a sample from a bundle without editing the sample did not work.

2022-07-25 - Version 2.7.4
- Improved: File browser file sorting [SHIFT]+[OPT] is no longer cleared when returning to the file browser unless the directory has been changed
- Fix: False boot-up error could occur on version 2.7.3 while detecting hardware
- Fix: Wavsynth VOL command help text showed the wrong value
- Fix: Instrument view - deleting characters [OPT]+[EDIT] in the instrument name could result in parameter values being displayed incorrectly
- Fix: Sample/Instrument preview could result in unexpected results when loading a sample

2022-07-08 - Version 2.7.3
- New: Create directory added to file browser when saving
- Improved: File browser general improvements, larger viewing area
- Improved: New MIDI note input poly mode behavior for allocating track voices properly
- Improved: Sample preview no longer uses current instrument's slice & transpose settings
- Fix: MIDI Settings view MIDI input instrument assignments now reflect incoming program change messages
- Fix: MIDI poly mode did not work on MIDI channel 16
- Fix: FMSynth CLK osc could set the wrong phase if previously playing instrument used CLK osc
- Fix: Project / Song save directory was reset on power cycle

2022-07-01 - Version 2.7.2
- Improved: New boot menu for optional settings and testing. Hold [SHIFT]+[OPT] when powering on
- Improved: Playback can now be stopped while in file browser by toggling [SHIFT]+[PLAY]
- Fix: Midiout CCI and CCJ was nonfunctional
- Fix: Sampler did not respond to MIDI pitchbend wheel
- Fix: FMSynth could overload the filter resulting in channel not working until reboot

2022-06-24 - Version 2.7.1
- Improved: File save overwrite warnings added for Instruments, Themes, and scales. 
- Improved: Added command effect help text for synth parameters that have fixed values (Filter type, limit type, Osc shape etc)
- Improved: Sampler PLY command effect now continues playback even after end was previously reached
- Fix: Sampler PIT command effect did not work correctly on low notes in slice mode when instrument transposition was engaged
- Fix: 2.7.1A - Small fix for sample LFO loop mode ("timestretch")
- Fix: 2.7.1C - Small fix for stem rendering taking a long time

2022-06-24 - Version 2.7.1
- Improved: File save overwrite warnings added for Instruments, Themes, and scales. 
- Improved: Added command effect help text for synth parameters that have fixed values (Filter type, limit type, Osc shape etc)
- Improved: Sampler PLY command effect now continues playback even after end was previously reached
- Fix: Sampler PIT command effect did not work correctly on low notes in slice mode when instrument transposition was engaged
- Fix: 2.7.1A - Small fix for sample LFO loop mode ("timestretch")
- Fix: 2.7.1C - Small fix for stem rendering taking a long time

2022-06-21 - Version 2.7.0
- New: Song view: Selection render - While playback is stopped, create a selection and double tap [EDIT]
- New: Song view: Time info - While playback is stopped, hold [OPT] on a song row to display song time and tick information
- New: Mixer & Project - Song snapshot and recall - Use [SHIFT]+[OPT] to create snapshot, [SHIFT]+[EDIT] to recall
- New: FM Synth osc shape "CLK" creates a single cycle sin useful for transient where FB sets phase position of connected OPs
- New: FM Synth noise osc S&H amount to feedback parameter
- New: FM Synth 3 new filtered noise osc shapes with feedback parameter mapped to filter resonance
- New: Midiout instrument PORT parameter now has an internal mode
- New: Effect Settings view can now be MIDI/Touchscreen mapped
- New: Mute/Solo now mapped to MIDI notes on control channel (starting from 2nd lowest octave)
- New: Midiout Bank MSB (CC0) is now sent before program change messages
- Improved: MIDI mapping screen now allows editing assigned MIDI channel
- Improved: Song queue loading more seamless, saving song no longer causes audio dropouts
- Improved: Better multi-instrument handling on same track when using send effects. Less clicks
- Improved: When using the TBL command, the table now plays at the speed the instrument is set to
- Improved: Instrument volume interpolation improvements
- Improved: Table tick speed FF (200hz mode) improvements with alignment of instrument triggers
- Improved: Play button in oscilloscope mode no longer exits mode
- Improved: Sample editor [OPT]+[LEFT] and [RIGHT] now snaps to 16th notes
- Improved: Instrument tables are now stopped when a KIL command is executed
- Improved: MIDI Settings view now displays instrument name when editing instrument assignments
- Improved: Instrument name help text - Sample name now displayed when no instrument name is set
- Fix: Note C-1 with PIT command could be ignored
- Fix: Tempo could not reach 999 BPM from last version
- Fix: Rendering length could be slightly incorrect
- Fix: Phrase playback while navigating phrase could double-trigger first row
- Fix: Sampler slice mode could show the wrong note played in the right-side note display
- Fix: Sampler could have clicks/artifacts on ping-pong sample playback
- Fix: HOP command in phrase did not work correctly with the first HOP digit
- Fix: Typo in help text for fast-table mode (400hz, where it's actually 200hz)
- Fix: Midimap view display rendering issues when editing midimapping above 16
- Fix: Playback issues switching between phrase playback and song livemode queue was possible
- Fix: M8 would become out of sync in MIDI clock receive mode when song queue load is used
- Fix: Scale issues with Sampler slice mode
- Fix: Rendering could report going over 100% complete under certain conditions

2022-04-26 - Version 2.6.0
- New: Macrosynth models added - FLUTED, DIGITAL MOD, MORSE NOISE
- New: Delay now works with feedback set to zero (single-shot delays now possible)
- New: Sample Editor values that use sample position now support OPT+Navigating for snapping to song tempo
- Improved: MIDIOUT program change and bank improved when using the same instrument in multiple tracks
- Fix: Sampling during playback now disables currently selected track to prevent audio dropouts in recording
- Fix: Song tempo could be mismatched between project view and right side tempo indication
- Fix: MIDI output transport could send the wrong song position value
- Fix: REP and RND commands reset when playing in single phrase mode and navigating between phrases
- Fix: Sampler in OSC mode and modulating LOOP START position could stop sample playback

2022-01-30 - Version 2.5.3
- New: Tables can now pause with HOP command fx when it matches the row it's on
- Improved: Midiout now uses scale intervals for ADD and CHD commands
- Improved: ARP command now uses scale intervals
- Improved: Do not reset file browser path for samples when loading a new sample
- Fixed: FMSynth PIT to ignore scales when instrument transpose is disabled
- Fixed: Repeated RAN (Random) command with instrument retriggers could result in negative values
- Fixed: Small audio dropout when using RAN (Random) could occur
- Fixed: "ERROR IN SAMPLE FORMAT" on previewing sample folders
- Fixed: Reverb no longer "pops" on start-up if there is no splash screen startup song
- Fixed: Potential crash on render view when deleting characters in the file name
- Fixed: Sampler large pitch LFO values could prohibit sample playback
- Fixed: FMSynth microtonal issues with PIT mod destinations
- Fixed: Typo in help text for REP in table

2022-01-17 - Version 2.5.2
- Fixed: Stem rendering always rendered reverb regardless of settings
- Fixed: Sample editor - loop region end point marker not clearing when exiting sample editor
- Fixed: MIDIOUT instrument constantly triggered when note was transposed under 00 in table
- Fixed: Groove view play position marker was not reset properly when switching grooves via GRV command

2022-01-12 - Version 2.5.1
- New: Multimode filter - LP>HP is a lowpass filter with RES controlling a 1 pole highpass
- Fixed: Potential hard-crash while previewing samples
- Fixed: Potential hard-crash while using Macrosynth plucked
- Fixed: Rendering stems now includes global fx commands from adjacent tracks
- Fixed: Sample editor to clear out loop markers when saving with slice cue points

2022-01-04 - Version 2.5.0F
- Improved: Handling overlapping notes when recording notes via MIDI input
- Fixed: Wavsynth did not respect Instrument transpose disable for scales

2022-01-03 - Version 2.5.0E
- Fixed: Midiout did not respect Instrument transpose disable for scales
- Fixed: Note preview when using a different "KEY" in scale was incorrect

2021-12-30 - Version 2.5.0D
- Fixed: MIDI sync output song position pointer was always sending 0
- Fixed: Sample Editor "PROCESS:SLICE##" only went to 31 instead of 32

2021-12-28 - Version 2.5.0C
- Fixed: Possible crash when using SCA command and editing notes in phrase
- Fixed: Mixer volume fx commands for effects (VCH,VDE, amd VRE) were not working correctly
- Improved: Drawing performance / optimizations of waveform in sample editor view

2021-12-25 - Version 2.5.0A
- Fixed: Pitch "PIT" fx command no longer worked for sliced samples

2021-12-24 - Version 2.5.0
- New: Scale and microtonal support, new view can be found above groove
- New: Dual mono input mode. Allows two independent mono sources into the mixer with fx sends
- New: Wav file loop marker support, can be edited in the sample editor screen and stored with the wav file
- New: Wav file slice marker support (limited to 32). Can be edited in the sample editor screen and stored with the wav file
- New: Sample editor now has auto-slice and slice marker generation support in the "process" options
- New: "POST: AD" LIMIT/CLIP mode - analog drive
- New: PBN fx command for allowing continuous pitch bend sliding up or down
- New: Mixer audio input fx commands for controlling volume and effects send levels
- New: TSP fx command to control global note transpose
- New: SNG fx command for hopping the given track to a specific song row
- New: Sampler SLI command for cuing specific slice markers from file
- New: Track MIDI input now supports poly mode, all tracks with the same MIDI channel will work in round-robin
- New: Track MIDI input now recognizes Sustain pedal (cc64)
- New: MIDI recording now has separate options for recording KILL and/or DELAY commands
- New: Phrase and Table views now allow selection nudging if multiple rows and columns are selected using EDIT+UP/DOWN
- New: Font - New lowercase option in the Theme view
- Improved: Macrosynth "Plucked" shape now has 6 voices
- Improved: Phrase and table no longer wrap when pasting data
- Improved: Instrument preset load now allows loading of samples
- Improved: THO in table now "HOPs" all columns, giving it a unique feature over HOP
- Fixed: FMsynth OP 00 volume could alter the timbre/phase of the overall sound
- Fixed: FMsynth SAW wave had the wrong phase offset when reset or triggered
- Fixed: Bookmarks on Track 0 row 00 could be removed by deleting a chain in song view
- Fixed: MIDI Instrument could send program change 00 when editing the PG value
- Fixed: Note keyboard would disappear when connecting to remote display
- Fixed: Deep cloning when out of phrases had no error message
- Fixed: Loading samples with a path that was too long displayed no error message
- Fixed: Phrase view would sometimes highlight last row when navigating
- Fixed: Freeze/crash could occur with MIDI transport output set to SONG
- Fixed: Very long samples could result in stopping sample playback and/or sample artifacts

2021-11-27 - Version 2.0.9
- New: Mini keyboard when in phrase, table, and instrument screens
- Improved: Minor tweak to the font for "8" to distinguish from "B"
- Improved: Startup sound now plays through headphones only when present. Max volume of the jingle is also lowered.
- Improved: Auto sleep / powerdown is disabled when audio input has an active signal 
- Improved: MIDI output sync clock always sent when activated in settings
- Improved: MIDI map mode now works like a cue mode when in "LIVE" mode
- Fixed: Hardcrash when set to send MIDI song position when in loop selection mode
- Fixed: RAN (random) command was offset by 1. RAN01 or RAN10 did nothing.
- Fixed: FM Synth could not use LFOs on some of the same parameters as the envelopes (eg: volume)
- Fixed: Wavsynth OSC FX command would be delayed when switching to NOISE shape
- Fixed: Midiout Inst. to only send program changes when chnaged. MPG (program change) fx always sends program change. 
- Fixed: Incoming MIDI notes ignored Table TIC00
- Fixed: Sampler OSC mode could play incorrect pitch/size when automating loop start position
- Fixed: Rendering a song with tempo changes could cut rendering shorter than song length
- Fixed: RET retrigger command now does not also retrigger groove GRV commands
- Fixed: RET10 (retrig once) command causes note to retrigger again after an extended period of time
- Fixed: OUTPUT VOLUME in project screen could jump well past E0 when quick editing (UP) above D0
 

2021-10-22 - Version 2.0.8B
- Fixed: Fatal crach when using MIDI OUTPUT "SONG" transport mode.
 
2021-10-21 - Version 2.0.8
- Improved: Better battery life- especially when unit is turned off. better battery life % gauge, better handling of low battery.
- Fixed: Midi note input while using external MIDI sync without sync present caused first note to not play
- Fixed: Midi note recording could show phrase notes from another phrase
- Fixed: DEL (Delay) FX command with a 00 value would not trigger note/row
- Fixed: MIDI song position receive did not work with song rows greater than 57
- Fixed: Sample "pingpong" loop mode did not work on occasion.
- Fixed: Multi-scope easter-egg now disables remote display while active.
- Fixed: Bundling invalid instruments could cause a crash.
- Fixed: Battery meter on production unit could occasionally show the wrong value.
- Fixed: Crash mitigation from 2.0.X
- Fixed: USB Serial could result in button presses when not connected to remote application from other bad programs
- Fixed: FMsynth would cease to work when note pitch was very high due to modulation slots.
- Fixed: Command FX interpolation action ([SHIFT]+[EDIT] on a selected range) now works with FF values.
- Fixed: Song and rendering screen names could end up having a space as the name after deleting all characters
- Fixed: Limit tap tempo to 999BPM
- Fixed: Note preview with table transpose could be heard improperly
- Fixed: FX command help screen could show the wrong instrument commands
- Fixed: Instrument name help text used a decimal value to display the instrument number 
- Fixed: Exiting selection mode in phrase and editing the highlighted cell resulted in the wrong cell being edited
- Improved: When M8 crashes your song/changes are not lost.
- Improved: Power button power-off time increased from 0.5 seconds to 1 second and added help message.
- Improved: MIDI input note recording quantization improved.
- Improved: DEL (Delay) FX command now fully works with CHA (chance) and RAN (random) commands
- Improved: REP (Repeat) fx command now works with absolute instrument commands like LFO frequency etc.
- Improved: TAB (Table) fx command now previewed with notes in phrases.
- Improved: Song and sample overwrite warning messages added
- Improved: HOPFF now has a help message
- Improved: Crash mitigations and song instrument memory validation 
- Improved: Battery meter on production hardware

2021-09-19 - Version 2.0.7
- Fixed(!!!): Hardware detection (beta vs production hardware) fix for some M8 production units that failed detection.
- Fixed: Battery level indicator less aggressive range.
- Fixed: Theme view - clearing name exited view.
- Fixed: Macrosynth "PLUCKED" polyphony.
- Fixed: Battery level indicator was broken on theme view.

2021-09-15 - Version 2.0.6B
- Fixed: Exiting sample editor cleared instrument settings.

2021-09-13 - Version 2.0.6
- Fixed: Sample editor - "PASTED INSTRUMENT" odd behavior/issue and showing the temp file as the sample name when exiting.
- Fixed: Randomize instrument results in wrong note pitch
- Fixed: Headless "CPU TOO BUSY" message from Version 2.0.5

2021-08-23 - Version 2.0.5
- Removed MIDI TRS type selection from MIDI settings
- Added secret headphone protection disable option via file
- Improved: Instrument paste on instrument screen now has undo
- Improved: Note preview and MIDI input notes are now part of a queue system for stability
- Improved: Theme is saved and temp song saved on hardware and headless when exiting remote display application
- Improved: Randomize instrument shortcut easter egg changed (???)
- Fix: Potential crash on MIDI receive sync modes
- Fix: Wav file "ERROR READING SAMPLE FORMAT" error fix on certain files
- Fix: SD card removal could result in playback halting until a hard reset
- Fix: When connecting to PC display application while in the effect help screen, navigation could get stuck
- Fix: FM synth OP was frozen if the op level is 0
- Fix: Macrosynth did not fully reset state when retriggered. Some transients were lost
- Fix: Bookmarks would not persist correctly when deleting or adding song rows
- Fix: Keymapping MIDI support using control MIDI Channel now works in "ALL" mode via MIDI channel 16
- Fix: Chain view could go out of range, added message when there is no phrase in chain and attempting to navigate
- Fix: Theme color changes to Value text resulted in the color swatches getting chopped
- Fix: Crash when interpolating an empty range on a new project

2021-06-13 - Version 2.0.4
- Fix: HEADLESS "CPU TOO BUSY" on FM synth
- Fix: Bundling instruments file name issue

2021-06-09 - Version 2.0.3
- New: Physical output volume setting hearing protection - If volume is above "F0", volume is reset to "F0" on power up and disconnecting/inserting headphone jack.
- New: Bundling a song now exports all instruments in a new subfolder "Instruments"
- Improved: Maximum output volume increased
- Improved: Performance/CPU optimizations
- Improved: Remote display - only send button presses when they are changed
- Fix: Table - last row did not work if tic was set to FF
- Fix: MIDI Mapping multiple instruments when viewing instrument screen caused mapping issues
- Fix: Sample editor - Zoomed selection movements was inaccurate and had visual artifacts
- Fix: Sampler - Note preview occasionally not working on slice mode

2021-06-04 - Version 2.0.2
- Fix: MIDI mappings could have erratic behavior if viewing mapped Instrument or Mixer
- Fix: Changing tempo while playing back could slow down tempo for a brief period
- Fix: MIDI out instrument - port selection would not take place until after instrument is triggered

2021-06-01 - Version 2.0.1
- Fix: File browser default sample/instrument selection was wrong
- Fix: Help messages on command effects did not work if there was no instrument on current row
- Fix: FM synth could stop all audio if note previewing track for the first time on power-up
- Improved: Beta M8 - Faster screen drawing performance when switching screens
- Improved: Production M8 - Display gamma/color calibration

2021-05-29 - Version 2.0.0 - Official Production Unit Version Support
- New: Second LFO added to all synth engines along with command effects
- New: Main output "DJ" style filter (lowpass to highpass with center being no filter) in the mixer screen
- New: Tick based LFO modes (faster than step based) scroll past last shape to select a tick based version
- New: Mixer volumes are now "pre" values, turning down a track will also turn down sends to reverb, chorus, and delay
- New: Display backlight control in Theme settings for hardware M8
- New: REP (repeat command) now works on Sequencer and Mixer commands
- New: REP (repeat command) now does tick-rate parameter updates (less steppy)
- New: RET (Retrigger) command has been reworked. Retrig values that were repeats now have new behavior
- New: RET (Retrigger) When used in a table, table no longer resets to start position 
- New: DEL (note/row delay command) is now independent from other note events- delayed row will trigger in XX ticks
- New: CHA (Chance command) No longer work on table HOP. Allows aligned columns to apply those commands without HOP breaking
- New: NTH Command - Conditional trigger based on phrase repeat intervals
- New: SED Command - Random seed - Set the seed of the random number generator to lock in random results
- New: VCH, VDE, VRE Commands - Volume Chorus, Volume Delay, and Volume Reverb commands for setting effect output mixer volumes
- New: VT1 to VT8 and DJF - Mixer effect commands for Volumes and Main filter
- New: FM Synth New alternate OP shapes
- New: FM Synth phase set command to trigger an exact phase offset
- New: Macrosynth command effect for striking/trigger specific shapes (like plucked and kick- Shapes 1C to 23)
- New: Midiout instrument now has port selection option
- New: Groove screen help messages
- New: Project global transpose now has help message 
- New: MIDI mapping help message when assigning and clearing MIDI mappings
- New: Delete/cut [OPT+EDIT] no longer clears midi mapping unless the parameter is set to it's default value
- New: Song screen selection mode edit actions (EDIT+UP/DOWN to push/collapse empty spaces) 
- Fix: Macrosynth Hard crash fix
- Fix: Sample playback hard crash fix on hardware 
- Fix: File Browser could crash M8/Headless if number of files in viewed directory was over 512
- Fix: Mini-map had graphical glitch when navigating between phrases using OPT+LEFT/RIGHT
- Fix: Effect help screen did not work properly on the first row of the first phrase in song if there was no instrument
- Fix: C-1 would not work on "key jazz" in Touchdesigner display application
- Fix: Preview instruments with ARP had held note
- Fix: Tempo help message in table was wrong
- Fix: Reverse mode for 24 bit samples was broken
- Fix: Instrument file browser preview would break Sample browser previewing
- Fix: FM, Macro, and Wavsynth had relative FIN command wrap back to -1
- Fix: Note previewed in phrase when deleting a note
- Improved: LFO and ENV pan destination is now bipolar- Breaking change but easily adapted
- Improved: Renamed reverb damping to decay
- Improved: Selection Interpolation now is invalid if the start or end row is `--`
- Improved: Wavsynth's Filter types have been flipped around to better match other engines
- Improved: Wavsynth filter is drawn to oscope when using post filter modes
- Improved: MIDIMAP mapping range is now 00 to FF instead of 00 to 7F
- Improved: Cursor can now exit selection mode by cycling selection mode SEL+OPT+OPT+OPT+OPT
- Improved: Crash/timeout protection when saving data to SD card
- Improved: More anticlicky improvements when retriggering instruments
- Improved: Oscope has less artifacts on high pitched notes
- Improved: Double-tap Edit actions now have a timer window to detect double taps
- Improved: File Browser - Delete file confirm dialog now has "Cancel" as default selection

2021-05-14 - Version 1.3.8
- Fix from 1.3.5~1.3.7 - Potential crash fixes on hardware M8
- Fix: C-1 did not trigger correct pitch (played last note)
- Fix: Crash on active selection playback while MIDI send transport is enabled

2021-05-10 - Version 1.3.7B
- Fix: 24bit sample slice mode had wrong sample offsets
- Fix from 1.3.6 - Potential crash fixes on hardware M8
- Fix from 1.3.7 - Sample browser preview was broken
- Fix from 1.3.7 - MIDI input Note offs were ignored while in MIDI sync mode

2021-05-08 - Version 1.3.7
- Improved: general instrument retrigger clickies mitigation
- Improved: KILL command audio clicky mitigation
- Fix: Midiout Bank select did not work
- Fix: Headless could give battery power error when attempting to sample
- Fix: Changing main output volume and speaker volume had clickies on hardware
- Fix: MIDI Instrument: Bank number was not transmitted via USB
- Fix: Note preview was quickly playing the first row of table
- Fix: Switching between Macrosynth plucked and a sample in the same track could result in audio artifacts
- Fix: Table HOPs to reset Table REP counters (REP did not work after hopping back)
- Fix: RET from 1.3.5 / 1.3.6 caused weird artifacts on synthesis from restarting

2021-04-24 - Version 1.3.6
- New: Reworked USB Audio - Audio dropouts / clicky audio fixes
- Improved: Instrument Screen - Triggering accidental copy/paste prevention
- Improved: Chain Screen - Added TSP help message

2021-04-21 - Version 1.3.5
- New: 32bit DAC output support
- New: 24 Bit Wave file support added for playback and editing (limited 1 octave up for stereo, 2 octaves up for mono)
- New: MIDI - Song position offset support for MIDI transport send and receive mode
- New: File Browser - Instrument Presets File Browser - Preview instrument files in browser by pressing START
- New: Song Screen - Shaded chains as darker color when no notes are present in chain
- New: Phrase and Table - Command effects help messages in bottom of screen
- New: Inst. Screen - Help messages for instrument time related parameters
- New: All screens - Help messages for copying, pasting, and cloning
- Improved: Samples - Better error message when sample fails to load 
- Improved: Samples - Better meta data handling for less "FAILED TO LOAD" errors
- Improved: Instrument Envelopes and LFO interpolating improvements
- Improved: Instrument - Better / sharper transients when switching instruments in the same track
- Improved: Phrase - Cloning tables and grooves now possible from FX command value column
- Improved: Sample OSC mode looping short samples improved interpolation and oversampling
- Improved: Phase - "*" next to phrase number when the phrase is used in other chains of song
- Improved: Groove commands in table now implemented. (Changes groove in the currently playing track)
- Improved: FMsynth scope is better/more accurate
- Fix: PSL command never reached destination note, slewed non-linearly. Old songs may need to be adjusted due to formula error
- Fix: Phrase - Command fx names could be displayed as `---` when no instrument is in phrase
- Fix: Bundle - Creation failed when samples could not be found
- Fix: Cursor - Selection Mode had a visual bug if you triggered SELECT+OPT after moving selection left or right
- Fix: Song Screen - Cutting a large scrolled set of rows could result in cursor hopping to song row FF 
- Fix: Rendering - Stem mode "repeat" was broken
- Fix: Minor typo in HOP command help text
- Fix: Chain screen OPT-UP/DOWN and OPT-LEFT/RIGHT navigation fixes
- Fix: Fast table (FF) did not work while M8 was in receive MIDI sync mode
- Fix: Rendering stems issue with custom start and length parameters
- Fix: Rendering song had an extra 64 samples at the end of the rendered waveform

2021-02-22 - Version 1.3.4
- New: Render Screen - Stem rendering option for rendering selected tracks individually all at once.
- Improved: fm synth optimizations
- Fix: Macrosynth "Plucked" shape/osc polyphony was broken
- Fix: Chain and Phrase - Visual issue on screen titles "CHAIN" and "PHRASE" when OPT+DIRECTION navigating in LIVE mode. 
- Fix: Sample editor: Rendering issues on zoomed waveform
- Fix: Sample editor: Empty waveform view when canceling save warning

2021-02-02 - Version 1.3.3
- Improved: Screen navigation and sample editing redrawing/flicker prevention
- Fix: Phrase REP (Repeat) Command - Retrigging instruments resulted in wrong command value if initial command value was not zero
- Fix: Phrase - Note preview for instruments with global transpose disabled were still transposed
- Fix: Sample Browser - Sample preview was not respecting instruments with global transpose disabled 
- Fix: Synth Envelops - If all envelope settings were 0, command effects for the envelope were ignored
- Fix: Potential hard-crash while using MIDI SONGMAP mode 

2021-01-21 - Version 1.3.2
- Fix: Potential hard-crash while in instrument screen while instrument is playing
- Fix: Sample browser note preview (START) might apply global song transpose multiple times

2021-01-17 - Version 1.3.1
- Fix: Sample synth - When battery is below 50%, minor sample playback issues could occur
- Fix: Sample synth - Sequencer was ignoring or improperly triggering sample when using the STA (Sample start) command after sample was already playing
- Fix: Instrument screen - FM synth Mini-map graphics highlighted "E" (white in default theme)
- Fix: Phrase view - Navigating shortcut OPT+LEFT or OPT+RIGHT to navigate between tracks resulted in Mini-map display error 

2021-01-11 - Version 1.3.0
- New: 4op 12 algorithm FM Synth 
- New: Mixer screen - Display peak DB as message while editing volumes
- Improved: Instrument name or sample is displayed in message area when editing Instrument number in Phrase  
- Improved: Browsing Instruments in Instrument screen set the default instrument number to insert in Phrase
- Improved: Instrument save and load protection / checking
- Fix: Sample slice mode could result in left and right channels being flipped on certain slices
- Fix: Song Rendering - Disabled tracks still rendered the first note on the first row if it was present
- Fix: MIDI in Record channel could insert / preview the wrong instrument
- Fix: Synth amp LIM "SIN" mode could result in audible clicks/artifacts
- Fix: Phrase screen disabled selection interpolation on instrument and command columns
- Fix: Phrase screen cloning error when attempting to clone columns that cannot be cloned
- Fix: Minor sample playback fixes
- Fix: Sample editor: Auto-power off while in in editor messed up instrument's sample
- Fix: Sample editor overwrite on bundle samples did not overwrite original sample
- Fix: Sample editor had some extra meta data in the display for wave files that contained meta data
- Fix: Sample editor processes (normalize, 8bit, mono, downsample) did not work properly with samples that contained meta data
- Fix: Sample editor normalize selection normalized the wrong selection area on small samples 

2020-12-29 - Version 1.2.2
- New: Groove screen allows 0 as a tick entry. 0 = skips the current phrase row. Allows easy triplets and 3/4 time sig without hops or delay commands.
- Improved: Groove screen - Added play position indication ">"
- Improved: MIDI Control channel can now respond to all MIDI channels, scroll past 16 to "ALL" in MIDI settings
- Improved: Song load time faster for queued song loading (loading song while another song is playing)
- Improved: Recording/Sampling is disabled if battery is too low and not charging
- Improved: Wavsynth had clicks when retriggering instrument 
- Improved: Sample start position command effect smoothing (clickless start position sequencing)
- Improved: Reset all effects on boot-up
- Fix: Possible hard crash while previewing samples 
- Fix: Phrase note insert value was set to "---" when selection was active while editing notes
- Fix: Selection mask (SELECT+OPT) display redrawing clean up (screen flickering)
- Fix: Clear all copy buffers on loading/creating songs
- Fix: Render Screen file name validation / UI improvements
- Fix: Sample Editor Screen spelling error on CROP processing message
- Fix: MIDIOUT Instrument CC value command effects to work even if instrument's value is set to "--" 
- Fix: Velocity column was not skipped when using Chance 
- Fix: Song screen Bookmarks could be created on mute/solo key actions
- Fix: Song screen Bookmarks worked in mixer screen
- Fix: Song screen Bookmarks are now cleared / moved when song rows are cleared / moved
- Fix: Instruments - Mixing of table tic FF with other speeds on the same table could cause audio artifacts

2020-12-23 - Version 1.2.1
- Fix: Song Screen - Song row selection (SELECT+OPT+OPT) moving to incorrect row on copying selection.
- Fix: Sample Playback - Reverse modes (rev, rev-pp, ...) would stop playback when sample rate was exceedingly low
- Fix: Rendering - Deselecting tracks also disabled non-instrument commands (Tempo / effects etc) from those disabled tracks  
- Fix: MIDI Sync receive mode still responded in Sample recording and rendering modes
- Fix: Tempo would slowly drift out of time while samples were playing
- Improved: Sample playing/streaming from SD
- Improved: USB output dropouts while playing samples
- Improved: Low Power mode only triggered when volume is below -50db and playback is stopped to avoid dropouts while listening to audio input

2020-12-20 - Version 1.2.0
- New: Song Screen bookmarks added (change the color of a chain in song screen for visual aid). TAP OPT 3 times to add or remove a bookmark on the current cursor position.
- New: Render audio implemented (via project screen) Notes: Renders are located in "/Renders" and files are never overwritten- new renders with same name are incremented "test_2.wav", "test_3.wav"
- New: Sample editing and recording, accessible via Instrument screen to the right of the sample name on SAMPLE engine.
- Fix: Addressed USB Audio input dropouts/clicks
- Fix: Navigating to Instrument screen could jump to Instrument 7F
- Fix: Issues with Sample while using LFO assigned to LOOP ST sample stops unexpectedly
- Fix: Switching PLAY to reverse via effect commands sample stops unexpectedly
- Fix: Stop playback when all tracks have hit HOPFF for queue loading & sample recording song mode
- Fix: Better sample handling (anti-dropouts/clicks)

2020-12-06 - Version 1.1.1
- Many audio and code optimizations to decrease latency to 1/4th from the previous versions. Much improved MIDI sync & MIDI Out to Audio input round trip timing
- USB Audio stability fixes
- File Browser: Audio clicks/dropouts removed while browsing files
- File Browser: Alphabetical sorting added. Sort the current directory by pressing SELECT+OPTION - Does not sort by default due to speed concerns
- Song queued load (loading a song while playing current song) switching transition is improved
- Sample synth - OSC play mode with slices implemented. New slices start at relative offset from where sample is currently playing
- Note Octave renumbered one octave up. Range from C-1 to G-B (was C-0 to G-A) A-4 is now A440
- Chain Screen TSP column default value will always be 00 
- MIDI Note Offs on SONG ROW CUE were not checking for last held note, any note off would stop the sequencer
- MIDI Instrument Legato behavior when Instrument column is empty on phrase (Sends note-off after new note on)
- Degrade code for Macrosynth and Sample had to change as it was incompatible with the lower latency. (Bad code, sorry)
- Fix: Fast Instrument naming could insert invalid characters
- Fix: Playhead ">" occasionally being displayed on Mixer screen
- Fix: VU Meters were not accounting for negative bias.
- Fix: MIDI Out Transport send was not working when MIDI out sync was disabed
- Fix: While Mute/Solo was activated, INPUT mixing changes were ignored 
- Fix: MIDI Input sync was offset depending on source's tempo

2020-11-22 - Version 1.1.0
- Stereo sample support (full-stereo signal, not converted to mono)
- Pan as destination to synth envelopes and LFO 
- Theme/Custom colors added- Accessible in Project screen
- File Browsing - Faster & betterer
- Song Screen Mute/Solo Selection added- Perform Mute/Solo to all selected tracks when selection mode is activated
- Song Screen & Mixer screen B+LEFT or B+RIGHT to solo all tracks left or right from cursor
- Song Screen "Deep clone" - SELECT+OPT to start a section, SELECT+EDIT to clone selection or SELECT+EDIT+EDIT to deep clone (clones all phrases inside of selected chains)
- Project Screen "CLEAR UNUSED" Phrases & Chains now removes duplicate
- Saving a song named "TEMPLATE" in the /System directory will be used when creating a new song
- Better save song error handling
- Dynamic CPU speed to for longer battery life
- Desktop USB display: Improved reliability
- HOP command in phrase now resets all previous HOP counters in phrase
- MIDI Note input: Improved legato handling
- MIDI Note input: Improved velocity curve
- MIDI Note input: Wakes screen on new notes
- MIDI Note input: Bug fix for hanging notes when using global project transpose
- MIDI Note input: Disable legato mode option in MIDI settings

2020-11-10 - Version 1.0.4
- New "Headless" M8 for using with a stock Teensy 4.1 See https://github.com/DirtyWave/M8HeadlessFirmware
- Improved sample stream handling (more stable)
- Faster display handling
- Remote display improvements - Added remote keyboard control and note keyboard mode. See https://github.com/DirtyWave/M8DisplayTouchdesigner 
- Improved song loading / queue during playback through USB
- LFT (LFO trigger command) while mapped to sample offset has better handling to skip to a position in the sample
- M8 could crash when SD card was ejected during playback
- Increased inactivity timeout to 15 mins (was 5)
- Inactivity was not trigger for some MIDI events
- RET (Retrig command) did not retrigger other commands when on phrase command column 3.

2020-24-10 - Version 1.0.3
- USB serial support for sending M8 display data to computer. See https://github.com/DirtyWave/M8DisplayTouchdesigner 
- RET (Retrig command) now works in table
- STA (Sample Start offset command) now retriggers sample at the given position if it is currently playing
- RAN (Random command) fixes for inconsistent ranges in both phrase and table
- Instrument paste (Select+Opt to copy, Select+Edit to paste) on sample instrument did not set sample correctly
- Entering notes in phrase would insert a C-0 in certain conditions
- Command column would reset to "---" when navigating to / from instrument screen
- Fixed phrase edit behavior when clearing inserted values
- Instrument reset confirmation dialog was not displaying when only changing samples
- MIDI Notes & pitch bend wheel issues when sync receive mode without sync
- MIDI input tracks on the same channel PB Wheel support
- MIDI Instrument Program Change command was not triggering properly on repeated values
- MIDI out start sync command should not trigger from note preview
- USB MIDI sync did not send start / stop messages
- USB Audio dropouts/clicks fixes for Windows
- Rewrote Sample data streaming for better performance
- Display drawing optimizations
- Increased sample pitch limits if sample is less than 44.1khz or 16 bit

2020-24-09 - Version 1.0.2
- File Browser fixed noise playback on holding [START] (preview sample) while navigating to "/.."
- Button input fine tuning for fast fingers or fat thumbs.
- New chain/phrase/table/instrument [EDIT+EDIT] double tap stability
- [OPT+UP/DOWN] on phrase in phrase playback mode was not working correctly.  
- Phrase and Table reset command values to 00 when editing from default 00
- CHA command (Chance) in table ignored entire table if tick was set to FF
- CHA command (Chance) in table had old inversed chance percentage value

2020-23-09 - Version 1.0.1
- LFO assigned to Volume had wrong shape direction
- Chain to phrase navigation was lost when navigating on an empty row '--'

2020-23-09 - Version 1.0.0
MIDI & Touchscreen
- Allow [TOUCH] to work while [OPTION] is pressed on non-assignable screens.
- MIDI CC and touch control added to Mixer Screen.
- Note/Sound playback while recording via MIDI.
- MIDI SETTINGS screen option to disable recording KILL commands.
- Allow multiple tracks to respond to the same MIDI channel.
- Do not stop sequencer on All-Notes-Off messages (MIDI CC#123)
- Better BPM display accuracy on MIDI sync.

User Interface / Interaction
- Various accidental inserts / edits fixed with button input. EG: Pasting then releasing [SELECT] before [EDIT]
- Cloning now looks for next available slot from current index instead of starting from zero.
- Selection mode now supports creating phrases and chains in empty columns.
- Selection mode in Chain screen supports cloning selection using [SELECT+EDIT]
- Selection mode Select-All & Copy Selection now moves cursor to the top left of selection on exit.
- Quick cut [OPTION+EDIT] now uses the copy buffer. [SELECT+EDIT] to paste.
- QWERTY Keyboard removed invalid file-system characters. (Resulted in unsavable songs and instruments)
- QWERTY Keyboard cursor now allows horizontal and vertical wrap.
- Command Help screen cursor now allows horizontal and vertical wrap.
- Command help screen text now easier to read. (It was too dark)
- File Browser now highlights previous directory when exiting a sub-folder.
- File Browser now recovers to default directory if previous directory is no longer available.
- File Browser [LEFT] to jump to top of directory list, [RIGHT] to jump to bottom of directory list.
- File Browser Save directory selection UI tweak for clarity.
- File Browser now selects the current sample by default.
- File Browser 31 character file name limit removed. (But highly suggest using short names) 
- Chain transpose column now inserts previously edited transpose values.
- Battery indicator no longer visually "jitters" between values.
- "Are you sure" dialog added to changing instrument type to prevent lost changes.
- Added Note-Preview option to Project screen for disabling note preview on inserting/editing notes.
- Output Volume on Project screen - [UP+EDIT] no longer makes large steps when volume is above E0. (Ear protection measure)
- Output Volume on Project screen - Key repeat on [RIGHT+EDIT] or [UP+EDIT] to increase volume slowed. (Ear protection measure)

MIDIOUT Synth
- CC value now defaults to "--" to not send CC value on instrument trigger.
- MPG command (MIDI Program Change) is now a absolute value.

Macrosynth
- KIL command (Kill note) now stops plucked model polyphony
- Oscillator state note retriggered on new notes for specific models

Global Synth changes
- VOL command (Volume) can now be assigned to both LFO and ENV simultaneously
- LFT command (LFO Retrigger) value now specifies the LFO position

Player 
- Chance command (CHA) changed. First digit: Chance all commands / notes to the left side, second digit: everything to the right.
- HOP command in table now resets all previous HOP counters in table.
- ARP command (Arpeggio) can now be set in table.
- RAN command (Random) Continuous RAN use on relative commands now uses base relative value.
- CHA command (Chance) Inverted the range for usability. 0->Zero probability, F->100% probability.
- Live mode - Individual chain lengths now respected before proceeding to the queued chain.
- Phrase playback now uses current chain's transpose column value.

Bug Fixes
- Selection value interpolation [SELECT+EDIT] now disabled if more than one column is highlighted.
- Selection value interpolation using [SELECT+OPT+OPT] to create selection did not work.
- Instrument paste [SELECT+EDIT] would reset instrument settings when nothing was copied.
- File Browser failed to reset scroll offset when opening browser screen resulting in a empty list.
- HOP command occasionally skipped on table when TIC rate was FF. 
- RET command (Retrig) help text for volume was backwards.
- RET command (Retrig) Volume scaling was offset incorrectly.
- VOL command (Volume) was wrapping back to zero or to max volume when automating.
- PSL command (Pitch Slide) on first step in phrase resulted in unexpected behavior.
- RAN command (Random) did nothing when table tick rate was set to 00. 
- RAN command (Random) value was off by 1 on both digits.
- ARP command (Arpeggio) would hold last note by one extra tick.
- TBL command (Table select) with a value of 80+ would start with the wrong tick rate (00 instead of 01)
- KIL command (Kill note) would restart table from beginning in table "automation" mode- (Tick 00)
- XDT command (Delay effect time) Delay time for right side was not being respected.
- USB Audio issues with playing back samples for the first time.
- Sample SLICE could cause crash when note number was greater than the number of slices.
- Synth LFO set to ONCE mode would not reset to 0 correctly.
- Instrument number in phrase without a note would trigger note C-0 instead of the last played note.
- Wrong tempo was displayed on power-on.
- Song playback would stop on an empty chain. It is now treated the same as no chain number: "--"
- Live playback would loop first phrase indefinitely if player started with selection mode activated.

2020-09-09 - Version 0.9.9
- Changed output volume mixing to use DAC
- Fixed visual artifacts "green squares" bug with instrument type change
